local Mockingbird = foundation.createMod();


Mockingbird:dofile("scripts/mmagic.lua")
Mockingbird:dofile("scripts/mmoonshine.lua")
Mockingbird:dofile("scripts/mlaunder.lua")
Mockingbird:dofile("scripts/mstonesoup.lua")
Mockingbird:dofile("scripts/memitters.lua")
Mockingbird:dofile("scripts/mcaravan.lua")

 --[[  ]]--



--[[---------------------------- NEW CUSTOM Generator set up  thanks Minotorious!----------------------------]]--

local COMP_CUSTOM_GENERATOR = {
	TypeName = "COMP_CUSTOM_GENERATOR",
	ParentType = "COMPONENT",
	Properties = {
        { Name = "MaxQuantity", Type = "integer", Default = 1000 },
        { Name = "GrowRate", Type = "float", Default = 1.0 }
    }
}

function COMP_CUSTOM_GENERATOR:init()
    comp = self:getOwner():getComponent("COMP_RESOURCE_GENERATOR")
    comp:setMaxQuantity(self.MaxQuantity)
    comp.GrowRate = self.GrowRate
end

Mockingbird:registerClass(COMP_CUSTOM_GENERATOR)

--NEW Setting up Parts to use custom generators  for scaling parts register on root for non-scaling register on main part - 3 intances on these 2 lines

Mockingbird:registerPrefabComponent("models/mockingbird.fbx/Prefab/Root_Part", { DataType = "COMP_BUILDING_PART", FeedbackComponentListToActivate = { { "PREFAB_ROOT_PART", "COMP_CUSTOM_GENERATOR" } } })
Mockingbird:registerPrefabComponent("models/mockingbird.fbx/Prefab/Root_Part", { DataType = "COMP_CUSTOM_GENERATOR",  Enabled = true, MaxQuantity = 10, GrowRate = 0.2 })



---------------------
-- Asset Processors --
---------------------
Mockingbird:registerAssetProcessor("models/mockingbird.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
Mockingbird:registerAssetProcessor("models/outfits.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
Mockingbird:registerAssetProcessor("models/markets.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

Mockingbird:registerAssetProcessor("models/containers.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
Mockingbird:registerAssetProcessor("models/outfits2.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
Mockingbird:registerAssetProcessor("models/outfits3.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
Mockingbird:registerAssetProcessor("models/caravan.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
Mockingbird:registerAssetProcessor("models/bluecar.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
---------------
-- Asset IDs misc, Animals, and Rainbarrel--
---------------
--roots and tiling
Mockingbird:registerAssetId("models/mockingbird.fbx/Prefab/Root_Part", "PREFAB_ROOT_PART")
Mockingbird:registerAssetId("models/mockingbird.fbx/Prefab/Tiling_Part", "PREFAB_TILING_PART")

--rainbarrel
Mockingbird:registerAssetId("models/mockingbird.fbx/Prefab/Awaterb_Part", "PREFAB_AWATERB_PART")

--animals
Mockingbird:registerAssetId("models/mockingbird.fbx/Prefab/Amonkey_Part", "PREFAB_AMONKEY_PART")
Mockingbird:registerAssetId("models/mockingbird.fbx/Prefab/Acat_Part", "PREFAB_ACAT_PART")
Mockingbird:registerAssetId("models/mockingbird.fbx/Prefab/Adog_Part", "PREFAB_ADOG_PART")





-----------------------
-- Monument Building --
-----------------------
Mockingbird:register({
    DataType = "BUILDING",
    Id = "MOCKINGBIRD_MONUMENT",
    Name = "MOCKINGBIRD_MONUMENT_NAME",
    Description = "MOCKINGBIRD_MONUMENT_DESC",
    BuildingType = "DECORATION",
    AssetCoreBuildingPart = "BUILDING_PART_MONUMENT_POLE",
    BuildingPartSetList = {
        {
		Name = "MOCKINGBIRD_LIST_NAME1",
	        BuildingPartList = {
                "AMONKEY_PART",
                "ACAT_PART",
				"ADOG_PART"
				
				
            }
        },
        {
        Name = "MOCKINGBIRD_LIST_NAME2",
           	BuildingPartList = { 
				"AFORTUNE_PART",
				"ALAMP_PART",
				"ADIRT_PART"
				
            }
        },
	    {
        Name = "MOCKINGBIRD_LIST_NAME4",
           	BuildingPartList = { 
				"ACARAVAN_PART",
				"ABLUECAR_PART"
            }
        },
		{
        Name = "MOCKINGBIRD_LIST_NAME3",
           	BuildingPartList = { 
				"AWATERB_PART",
				"ASTEW_PART",
				"ABOWL_PART",
				"ACLOTHES_PART",
				"ASACK_PART",
				"ABAR_PART",
				"AJUG_PART"
				
            }
        }
    },
	IsEditable = true
})



--------------------
-- Scaling Building Parts --
--------------------
-- if Security Mod Dog give security else decore  

if (foundation.isModLoaded("99ee3b3b-f103-41f0-a725-bc466a2fc6de")) then
Mockingbird:register({ 
    DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
    Id = "SECURITY_GENERATOR_FUNCTION",
    ResourceGenerated = "RESOURCE_SECURITY",
    IsForConsumer = true,
    IsInfinite = false
})

Mockingbird:register({
	DataType = "BUILDING_PART",
	Id = "ADOG_PART",
	Name = "ADOG2_NAME",
	Description = "ADOG2_DESC",
	IsMovableWhenBuilt = true,
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER",
		CoreObjectPrefab = "PREFAB_ROOT_PART",
		EndPart = "ADOG",
		FillerList = {
			"TILING"
    	},
		BasementFillerList = {
			"TILING"
       	},
		MinimumScale = 2,
		IsVertical = true
	},
		DesirabilityModifiers = {
		{
			Desirability = "DESIRABILITY_RESIDENTIAL",
			Type = "ADD",
			Radius = 20.0,
			Value = 0.5
		}
	},
AssetBuildingFunction = "SECURITY_GENERATOR_FUNCTION" 
})
Mockingbird:register({
	DataType = "BUILDING_PART",
	Id = "ADOG",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ADOG_PART"
	}
})
else
Mockingbird:register({
	DataType = "BUILDING_PART",
	Id = "ADOG_PART",
	Name = "ADOG_NAME",
	Description = "ADOG_DESC",
	IsMovableWhenBuilt = true,
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER",
		CoreObjectPrefab = "PREFAB_ROOT_PART",
		EndPart = "ADOG",
		FillerList = {
			"TILING"
    	},
		BasementFillerList = {
			"TILING"
       	},
		MinimumScale = 2,
		IsVertical = true
	},
		DesirabilityModifiers = {
		{
			Desirability = "DESIRABILITY_RESIDENTIAL",
			Type = "ADD",
			Radius = 20.0,
			Value = 0.5
		}
	}
})
Mockingbird:register({
	DataType = "BUILDING_PART",
	Id = "ADOG",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ADOG_PART"
	}
})
end

-- if  StreetPerformers Mod Monkey give entertainment else decore

if (foundation.isModLoaded("9475b42e-f880-4787-9b07-bec720fc90b6")) then

Mockingbird:register({ 
    DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
    Id = "ENTERTAINMENT_GENERATOR_FUNCTION",
    ResourceGenerated = "RESOURCE_ENTERTAINMENT",
    IsForConsumer = true,
    IsInfinite = false
})

Mockingbird:register({
	DataType = "BUILDING_PART",
	Id = "AMONKEY_PART",
	Name = "AMONKEY2_NAME",
	Description = "AMONKEY2_DESC",
	IsMovableWhenBuilt = true,
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER",
		CoreObjectPrefab = "PREFAB_ROOT_PART",
		EndPart = "AMONKEY",
		FillerList = {
			"TILING"
    	},
		BasementFillerList = {
			"TILING"
       	},
		MinimumScale = 2,
		IsVertical = true
	},
		DesirabilityModifiers = {
		{
			Desirability = "DESIRABILITY_RESIDENTIAL",
			Type = "ADD",
			Radius = 20.0,
			Value = 0.5
		}
	},
AssetBuildingFunction = "ENTERTAINMENT_GENERATOR_FUNCTION",
})
Mockingbird:register({
	DataType = "BUILDING_PART",
	Id = "AMONKEY",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_AMONKEY_PART"
	}
})
else
Mockingbird:register({
	DataType = "BUILDING_PART",
	Id = "AMONKEY_PART",
	Name = "AMONKEY_NAME",
	Description = "AMONKEY_DESC",
	IsMovableWhenBuilt = true,
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER",
		CoreObjectPrefab = "PREFAB_ROOT_PART",
		EndPart = "AMONKEY",
		FillerList = {
			"TILING"
    	},
		BasementFillerList = {
			"TILING"
       	},
		MinimumScale = 2,
		IsVertical = true
	},
		DesirabilityModifiers = {
		{
			Desirability = "DESIRABILITY_RESIDENTIAL",
			Type = "ADD",
			Radius = 20.0,
			Value = 0.5
		}
	}
})
Mockingbird:register({
	DataType = "BUILDING_PART",
	Id = "AMONKEY",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_AMONKEY_PART"
	}
})
end

--if  Authority Mod Cat give authority else decore

if (foundation.isModLoaded("93098b10-e659-49db-ae11-f08341972d46")) then
Mockingbird:register({ 
    DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
    Id = "AUTHORITY_GENERATOR_FUNCTION",
    ResourceGenerated = "RESOURCE_AUTHORITY",
    IsForConsumer = true,
    IsInfinite = false
})

Mockingbird:register({
	DataType = "BUILDING_PART",
	Id = "ACAT_PART",
	Name = "ACAT2_NAME",
	Description = "ACAT2_DESC",
	IsMovableWhenBuilt = true,
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER",
		CoreObjectPrefab = "PREFAB_ROOT_PART",
		EndPart = "ACAT",
		FillerList = {
			"TILING"
    	},
		BasementFillerList = {
			"TILING"
       	},
		MinimumScale = 2,
		IsVertical = true
	},
		DesirabilityModifiers = {
		{
			Desirability = "DESIRABILITY_RESIDENTIAL",
			Type = "ADD",
			Radius = 20.0,
			Value = 0.5
		}
	},
AssetBuildingFunction = "AUTHORITY_GENERATOR_FUNCTION",
})
Mockingbird:register({
	DataType = "BUILDING_PART",
	Id = "ACAT",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ACAT_PART"
	}
})
else
Mockingbird:register({
	DataType = "BUILDING_PART",
	Id = "ACAT_PART",
	Name = "ACAT_NAME",
	Description = "ACAT_DESC",
	IsMovableWhenBuilt = true,
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER",
		CoreObjectPrefab = "PREFAB_ROOT_PART",
		EndPart = "ACAT",
		FillerList = {
			"TILING"
    	},
		BasementFillerList = {
			"TILING"
       	},
		MinimumScale = 2,
		IsVertical = true
	},
		DesirabilityModifiers = {
		{
			Desirability = "DESIRABILITY_RESIDENTIAL",
			Type = "ADD",
			Radius = 20.0,
			Value = 0.5
		}
	}
})
Mockingbird:register({
	DataType = "BUILDING_PART",
	Id = "ACAT",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ACAT_PART"
	}
})
end

--Rainbarrel

Mockingbird:register({
	DataType = "BUILDING_PART",
	Id = "AWATERB_PART",
	Name = "AWATERB_NAME",
	Description = "AWATERB_DESC",
    IsMovableWhenBuilt = true,
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER",
		CoreObjectPrefab = "PREFAB_ROOT_PART",
		EndPart = "AWATERB",
		FillerList = {
			"TILING"
    	},
		BasementFillerList = {
			"TILING"
       	},
		MinimumScale = 2,
		IsVertical = true
	},
		BuildingZone = {
		ZoneEntryList = {
			{
				Type = {
					DEFAULT = true,
					NAVIGABLE = false
				},
				Polygon = polygon.createCircle( 0.3, {0, 0}, 8 )
			}
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_WELL",
	    DesirabilityModifiers = {
		{
			Desirability = "DESIRABILITY_RESIDENTIAL",
			Type = "ADD",
			Radius = 20.0,
			Value = 0.5
		}
	}
})
Mockingbird:register({
	DataType = "BUILDING_PART",
	Id = "AWATERB",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_AWATERB_PART"
	}
})
-------------------
-- Scaling Parts --
-------------------
Mockingbird:register({
	DataType = "BUILDING_PART",
	Id = "TILING",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_TILING_PART"
	}
})
