local Mockingbird = ...


---------------
--set up
---------------
Mockingbird:registerEnumValue( "RESOURCE_TYPE", "RESOURCE_USED" )
Mockingbird:registerAssetId("icons/Used.png", "ICON_USED")


---------------
-- New Resource UsedClothes 
---------------

Mockingbird:register({
    DataType = "RESOURCE",
    Id = "RESOURCE_USED",
    ResourceName = "RESOURCE_USED_NAME",
	OrderId = 15,
    Icon = "ICON_USED",
    ResourceTypeList = { "GOODS", "RESOURCE_USED" },
    IsTradable = true,
    ResourceLayoutType = "CRATES",
    VillagerBuyingPrice = { Resource = "GOLD", Quantity = 1 },
    DisplayInInventory = true
})
---------------
-- Asset IDs --
---------------

Mockingbird:registerAssetId("models/markets.fbx/Prefab/Aclothes_Part", "PREFAB_ACLOTHES_PART")

Mockingbird:registerAssetId("models/containers.fbx/Prefab/Asack_Part", "PREFAB_ASACK_PART")

--Outfits
Mockingbird:registerAssetId("models/outfits3.fbx/Prefab/DFemaleFront", "PREFAB_LAUNDER_FEMALE_FRONT")
Mockingbird:registerAssetId("models/outfits3.fbx/Prefab/DFemaleBelt", "PREFAB_LAUNDER_FEMALE_BELT")
Mockingbird:registerAssetId("models/outfits3.fbx/Prefab/DMaleFront", "PREFAB_LAUNDER_MALE_FRONT")
--new Path work
Mockingbird:registerAssetId("models/markets.fbx/Prefab/Aclothes_Part/PATH_F_1", "PATH_CLOTHES_WORK_C1")
Mockingbird:registerAssetId("models/markets.fbx/Prefab/Aclothes_Part/PATH_D_1", "PATH_CLOTHES_CUST_A1")
Mockingbird:registerAssetId("models/markets.fbx/Prefab/Aclothes_Part/PATH_E_1", "PATH_CLOTHES_CUST_B1")



Mockingbird:registerPrefabComponent("models/markets.fbx/Prefab/Aclothes_Part", {
    DataType = "COMP_BUILDING_PART",
    PathList = {
        {   
            PathType = "DEFAULT",
            WayPointList = {
                "PATH_CLOTHES_WORK_C1"
            }
        },
        {   
            PathType = "PICKUP",
            WayPointList = {
                "PATH_CLOTHES_CUST_A1"
            }
        },
        {   
            PathType = "PICKUP",
            WayPointList = {
                "PATH_CLOTHES_CUST_B1"
            }
        }
    }
})

--------------------
-- Scaling Building Parts --
--------------------

Mockingbird:registerAssetId("models/containers.fbx/Prefab/Asack_Part", "PREFAB_ASACK_PART")

Mockingbird:register({ 
    DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
    Id = "USED_GENERATOR_FUNCTION",
    ResourceGenerated = "RESOURCE_USED",
    IsForConsumer = true,
    IsInfinite = false
})

Mockingbird:register({
	DataType = "BUILDING_PART",
	Id = "ASACK_PART",
	Name = "ASACK_NAME",
	Description = "ASACK_DESC",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER",
		CoreObjectPrefab = "PREFAB_ROOT_PART",
		EndPart = "ASACK",
		FillerList = {
			"TILING"
    	},
		BasementFillerList = {
			"TILING"
       	},
		MinimumScale = 2,
		IsVertical = true
	},
AssetBuildingFunction = "USED_GENERATOR_FUNCTION"
})
Mockingbird:register({
	DataType = "BUILDING_PART",
	Id = "ASACK",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ASACK_PART"
	}
})





---------------
-- Building Part: Laundry --
---------------
Mockingbird:register({
    DataType = "BUILDING_PART",
    Id = "ACLOTHES_PART",
    Name = "ACLOTHES_NAME",
    Description = "ACLOTHES_DESC",
    IsMovableWhenBuilt = true,
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_ACLOTHES_PART"
    },
	BuildingZone = {
		ZoneEntryList = {
			{
				Type = {
					DEFAULT = true,
					NAVIGABLE = false
				},
				Polygon = polygon.createRectangle( {0.4, 0.2}, {0, 0} )
			}
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_LAUNDER",		
		DesirabilityModifiers = {
		{
			Desirability = "DESIRABILITY_RESIDENTIAL",
			Type = "ADD",
			Radius = 20.0,
			Value = 0.5
		}
	}
})
---------------
-- Building Function: LAUNDER --
---------------
Mockingbird:register({
    DataType = "BUILDING_FUNCTION_MARKET",
    Id = "BUILDING_FUNCTION_LAUNDER",
    Name = "BUILDING_FUNCTION_LAUNDER_NAME",
    IsPrivate = false,
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_LAUNDER", 
        Behavior = "BEHAVIOR_WORK"
    },
    TypeList = { "RESOURCE_USED" },
    IsOverrideCapacity = true,
    CapacityPerSlot = 50,
    InputInventoryCapacity = {
    },
    ResourceListNeeded = {
    },
    ResourceProduced = {
        { Resource = "RESOURCE_USED", Quantity = 1 },
    }
})
---------------
-- Job: LAUNDER --
---------------
Mockingbird:register({
	DataType = "JOB",
	Id = "JOB_LAUNDER",
	JobName = "JOB_LAUNDER_NAME",
	JobDescription = "JOB_LAUNDER_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
	-- UseWorkplaceBehavior = true,
    ProductionDelay = 20.0, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP", 
--		LeftHandObject = {
--		Model = "PREFAB_TOOL_WINE_MAKER_STICK",
--		WorkAttachName = "Scroll_Anchor", 
--		WalkAttachName = "Scroll_Anchor"
--	},
      FemaleFrontList = {
            "PREFAB_LAUNDER_FEMALE_FRONT",
        },
       FemaleBeltList = {
            "PREFAB_LAUNDER_FEMALE_BELT",
        },     
        MaleFrontList = {
            "PREFAB_LAUNDER_MALE_FRONT",
       },
		WalkAnimation = "WALKING",
		IdleAnimation = "MARKET_TENDER"
	}
})

Mockingbird:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_LAUNDER"
    }
})

Mockingbird:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_LAUNDER"
    }
})

Mockingbird:override({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_LAUNDER"
    }
})

Mockingbird:override({
    Id = "CITIZEN",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_LAUNDER"
    }
})